<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>CoglRenderer: Connect to a backend renderer</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-context-apis.html" title="Setting Up A Drawing Context">
<link rel="prev" href="cogl-context-apis.html" title="Setting Up A Drawing Context">
<link rel="next" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html" title="CoglOnscreenTemplate: Describe a template for onscreen framebuffers">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-context-apis.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-context-apis.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-CoglOnscreenTemplate---Describe-a-template-for-onscreen-framebuffers.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.top_of_page"></a>CoglRenderer: Connect to a backend renderer</span></h2>
<p>CoglRenderer: Connect to a backend renderer — Choosing a means to render</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer">CoglRenderer</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-is-renderer" title="cogl_is_renderer ()">cogl_is_renderer</a>                    (<em class="parameter"><code><span class="type">void</span> *object</code></em>);

<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="returnvalue">CoglRenderer</span></a> *      <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-new" title="cogl_renderer_new ()">cogl_renderer_new</a>                   (<em class="parameter"><code><span class="type">void</span></code></em>);
<span class="returnvalue">int</span>                 <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-get-n-fragment-texture-units" title="cogl_renderer_get_n_fragment_texture_units ()">cogl_renderer_get_n_fragment_texture_units</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()">cogl_renderer_connect</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);

enum                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID">CoglWinsysID</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-set-winsys-id" title="cogl_renderer_set_winsys_id ()">cogl_renderer_set_winsys_id</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID"><span class="type">CoglWinsysID</span></a> winsys_id</code></em>);
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID"><span class="returnvalue">CoglWinsysID</span></a>        <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-get-winsys-id" title="cogl_renderer_get_winsys_id ()">cogl_renderer_get_winsys_id</a>         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);
enum                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint">CoglRendererConstraint</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-add-constraint" title="cogl_renderer_add_constraint ()">cogl_renderer_add_constraint</a>        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> constraint</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-remove-constraint" title="cogl_renderer_remove_constraint ()">cogl_renderer_remove_constraint</a>     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> constraint</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-set-foreign-display" title="cogl_xlib_renderer_set_foreign_display ()">cogl_xlib_renderer_set_foreign_display</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">Display</span> *display</code></em>);
<span class="returnvalue">Display</span> *           <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-get-foreign-display" title="cogl_xlib_renderer_get_foreign_display ()">cogl_xlib_renderer_get_foreign_display</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);

<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    (<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()">*CoglXlibFilterFunc</a>)               (<em class="parameter"><code><span class="type">XEvent</span> *event</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
enum                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn">CoglFilterReturn</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-add-filter" title="cogl_xlib_renderer_add_filter ()">cogl_xlib_renderer_add_filter</a>       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()"><span class="type">CoglXlibFilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-remove-filter" title="cogl_xlib_renderer_remove_filter ()">cogl_xlib_renderer_remove_filter</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()"><span class="type">CoglXlibFilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-handle-event" title="cogl_xlib_renderer_handle_event ()">cogl_xlib_renderer_handle_event</a>     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">XEvent</span> *event</code></em>);

<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    (<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()">*CoglWin32FilterFunc</a>)              (<em class="parameter"><code><span class="type">MSG</span> *message</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-add-filter" title="cogl_win32_renderer_add_filter ()">cogl_win32_renderer_add_filter</a>      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()"><span class="type">CoglWin32FilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-remove-filter" title="cogl_win32_renderer_remove_filter ()">cogl_win32_renderer_remove_filter</a>   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()"><span class="type">CoglWin32FilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-handle-event" title="cogl_win32_renderer_handle_event ()">cogl_win32_renderer_handle_event</a>    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">MSG</span> *message</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-set-event-retrieval-enabled" title="cogl_win32_renderer_set_event_retrieval_enabled ()">cogl_win32_renderer_set_event_retrieval_enabled</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> enable</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-wayland-renderer-set-foreign-display" title="cogl_wayland_renderer_set_foreign_display ()">cogl_wayland_renderer_set_foreign_display</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">struct wl_display</span> *display</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-wayland-renderer-set-event-dispatch-enabled" title="cogl_wayland_renderer_set_event_dispatch_enabled ()">cogl_wayland_renderer_set_event_dispatch_enabled</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> enable</code></em>);
struct <span class="returnvalue">wl_display</span> * <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-wayland-renderer-get-display" title="cogl_wayland_renderer_get_display ()">cogl_wayland_renderer_get_display</a>   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.description"></a><h2>Description</h2>
<p>
A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> represents a means to render. It encapsulates the
selection of an underlying driver, such as OpenGL or OpenGL-ES and
a selection of a window system binding API such as GLX, or EGL or
WGL.
</p>
<p>
A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> has two states, "unconnected" and "connected". When
a renderer is first instantiated using <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-new" title="cogl_renderer_new ()"><code class="function">cogl_renderer_new()</code></a> it is
unconnected so that it can be configured and constraints can be
specified for how the backend driver and window system should be
chosen.
</p>
<p>
After configuration a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> can (optionally) be explicitly
connected using <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()"><code class="function">cogl_renderer_connect()</code></a> which allows for the
handling of connection errors so that fallback configurations can
be tried if necessary. Applications that don't support any
fallbacks though can skip using <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()"><code class="function">cogl_renderer_connect()</code></a> and leave
Cogl to automatically connect the renderer.
</p>
<p>
Once you have a configured <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> it can be used to create a
<a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> object using <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Many applications don't need to explicitly use
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-new" title="cogl_renderer_new ()"><code class="function">cogl_renderer_new()</code></a> or <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a> and can just jump
straight to <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-context-new" title="cogl_context_new ()"><code class="function">cogl_context_new()</code></a> and pass a <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> display argument so
Cogl will automatically connect and setup a renderer and
display.</div>
<p>
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglRenderer"></a><h3>CoglRenderer</h3>
<pre class="programlisting">typedef struct _CoglRenderer CoglRenderer;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-renderer"></a><h3>cogl_is_renderer ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_renderer                    (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Determines if the given <em class="parameter"><code>object</code></em> is a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a> pointer</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if <em class="parameter"><code>object</code></em> is a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>, else <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-new"></a><h3>cogl_renderer_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="returnvalue">CoglRenderer</span></a> *      cogl_renderer_new                   (<em class="parameter"><code><span class="type">void</span></code></em>);</pre>
<p>
Instantiates a new (unconnected) <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> object. A
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> represents a means to render. It encapsulates the
selection of an underlying driver, such as OpenGL or OpenGL-ES and
a selection of a window system binding API such as GLX, or EGL or
WGL.
</p>
<p>
While the renderer is unconnected it can be configured so that
applications may specify backend constraints, such as "must use
x11" for example via <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-add-constraint" title="cogl_renderer_add_constraint ()"><code class="function">cogl_renderer_add_constraint()</code></a>.
</p>
<p>
There are also some platform specific configuration apis such
as <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-xlib-renderer-set-foreign-display" title="cogl_xlib_renderer_set_foreign_display ()"><code class="function">cogl_xlib_renderer_set_foreign_display()</code></a> that may also be
used while the renderer is unconnected.
</p>
<p>
Once the renderer has been configured, then it may (optionally) be
explicitly connected using <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()"><code class="function">cogl_renderer_connect()</code></a> which allows
errors to be handled gracefully and potentially fallback
configurations can be tried out if there are initial failures.
</p>
<p>
If a renderer is not explicitly connected then <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a>
will automatically connect the renderer for you. If you don't
have any code to deal with error/fallback situations then its fine
to just let Cogl do the connection for you.
</p>
<p>
Once you have setup your renderer then the next step is to create a
<a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#CoglDisplay" title="CoglDisplay"><span class="type">CoglDisplay</span></a> using <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Many applications don't need to explicitly use
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-new" title="cogl_renderer_new ()"><code class="function">cogl_renderer_new()</code></a> or <a class="link" href="cogl-2.0-experimental-CoglDisplay---Setup-a-display-pipeline.html#cogl-display-new" title="cogl_display_new ()"><code class="function">cogl_display_new()</code></a> and can just jump
straight to <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#cogl-context-new" title="cogl_context_new ()"><code class="function">cogl_context_new()</code></a> and pass a <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> display argument
so Cogl will automatically connect and setup a renderer and
display.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly created <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>. <span class="annotation">[<acronym title="Free data after the code is done."><span class="acronym">transfer full</span></acronym>]</span>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-get-n-fragment-texture-units"></a><h3>cogl_renderer_get_n_fragment_texture_units ()</h3>
<pre class="programlisting"><span class="returnvalue">int</span>                 cogl_renderer_get_n_fragment_texture_units
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);</pre>
<p>
Queries how many texture units can be used from fragment programs
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>the number of texture image units.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-connect"></a><h3>cogl_renderer_connect ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_renderer_connect               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Connects the configured <em class="parameter"><code>renderer</code></em>. Renderer connection isn't a
very active process, it basically just means validating that
any given constraint criteria can be satisfied and that a
usable driver and window system backend can be found.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>An unconnected <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>a pointer to a <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for reporting exceptions</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if there was no error while connecting the
given <em class="parameter"><code>renderer</code></em>. <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> if there was an error.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglWinsysID"></a><h3>enum CoglWinsysID</h3>
<pre class="programlisting">typedef enum {
  COGL_WINSYS_ID_ANY,
  COGL_WINSYS_ID_STUB,
  COGL_WINSYS_ID_GLX,
  COGL_WINSYS_ID_EGL_XLIB,
  COGL_WINSYS_ID_EGL_NULL,
  COGL_WINSYS_ID_EGL_GDL,
  COGL_WINSYS_ID_EGL_WAYLAND,
  COGL_WINSYS_ID_EGL_KMS,
  COGL_WINSYS_ID_EGL_ANDROID,
  COGL_WINSYS_ID_WGL,
  COGL_WINSYS_ID_SDL
} CoglWinsysID;
</pre>
<p>
Identifies specific window system backends that Cogl supports.
</p>
<p>
These can be used to query what backend Cogl is using or to try and
explicitly select a backend to use.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-WINSYS-ID-ANY:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_ANY</code></span></p></td>
<td>Implies no preference for which backend is used
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-STUB:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_STUB</code></span></p></td>
<td>Use the no-op stub backend
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-GLX:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_GLX</code></span></p></td>
<td>Use the GLX window system binding API
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-XLIB:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_XLIB</code></span></p></td>
<td>Use EGL with the X window system via XLib
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-NULL:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_NULL</code></span></p></td>
<td>Use EGL with the PowerVR NULL window system
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-GDL:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_GDL</code></span></p></td>
<td>Use EGL with the GDL platform
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-WAYLAND:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_WAYLAND</code></span></p></td>
<td>Use EGL with the Wayland window system
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-KMS:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_KMS</code></span></p></td>
<td>Use EGL with the KMS platform
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-EGL-ANDROID:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_EGL_ANDROID</code></span></p></td>
<td>Use EGL with the Android platform
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-WGL:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_WGL</code></span></p></td>
<td>Use the Microsoft Windows WGL binding API
</td>
</tr>
<tr>
<td><p><a name="COGL-WINSYS-ID-SDL:CAPS"></a><span class="term"><code class="literal">COGL_WINSYS_ID_SDL</code></span></p></td>
<td>Use the SDL window system
</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-set-winsys-id"></a><h3>cogl_renderer_set_winsys_id ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_renderer_set_winsys_id         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID"><span class="type">CoglWinsysID</span></a> winsys_id</code></em>);</pre>
<p>
This allows you to explicitly select a winsys backend to use instead
of letting Cogl automatically select a backend.
</p>
<p>
if you select an unsupported backend then <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()"><code class="function">cogl_renderer_connect()</code></a>
will fail and report an error.
</p>
<p>
This may only be called on an un-connected <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>winsys_id</code></em> :</span></p></td>
<td>An ID of the winsys you explicitly want to use.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-get-winsys-id"></a><h3>cogl_renderer_get_winsys_id ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID"><span class="returnvalue">CoglWinsysID</span></a>        cogl_renderer_get_winsys_id         (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);</pre>
<p>
Queries which window system backend Cogl has chosen to use.
</p>
<p>
This may only be called on a connected <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>The <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWinsysID" title="enum CoglWinsysID"><span class="type">CoglWinsysID</span></a> corresponding to the chosen window
system backend.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="CoglRendererConstraint"></a><h3>enum CoglRendererConstraint</h3>
<pre class="programlisting">typedef enum {
  COGL_RENDERER_CONSTRAINT_USES_X11 = (1 &lt;&lt; 0),
  COGL_RENDERER_CONSTRAINT_USES_XLIB = (1 &lt;&lt; 1),
  COGL_RENDERER_CONSTRAINT_USES_EGL = (1 &lt;&lt; 2),
  COGL_RENDERER_CONSTRAINT_SUPPORTS_COGL_GLES2 = (1 &lt;&lt; 3)
} CoglRendererConstraint;
</pre>
<p>
These constraint flags are hard-coded features of the different renderer
backends. Sometimes a platform may support multiple rendering options which
Cogl will usually choose from automatically. Some of these features are
important to higher level applications and frameworks though, such as
whether a renderer is X11 based because an application might only support
X11 based input handling. An application might also need to ensure EGL is
used internally too if they depend on access to an EGLDisplay for some
purpose.
</p>
<p>
Applications should ideally minimize how many of these constraints
they depend on to ensure maximum portability.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-RENDERER-CONSTRAINT-USES-X11:CAPS"></a><span class="term"><code class="literal">COGL_RENDERER_CONSTRAINT_USES_X11</code></span></p></td>
<td>Require the renderer to be X11 based
</td>
</tr>
<tr>
<td><p><a name="COGL-RENDERER-CONSTRAINT-USES-XLIB:CAPS"></a><span class="term"><code class="literal">COGL_RENDERER_CONSTRAINT_USES_XLIB</code></span></p></td>
<td>Require the renderer to be X11
                                     based and use Xlib
</td>
</tr>
<tr>
<td><p><a name="COGL-RENDERER-CONSTRAINT-USES-EGL:CAPS"></a><span class="term"><code class="literal">COGL_RENDERER_CONSTRAINT_USES_EGL</code></span></p></td>
<td>Require the renderer to be EGL based
</td>
</tr>
<tr>
<td><p><a name="COGL-RENDERER-CONSTRAINT-SUPPORTS-COGL-GLES2:CAPS"></a><span class="term"><code class="literal">COGL_RENDERER_CONSTRAINT_SUPPORTS_COGL_GLES2</code></span></p></td>
<td>Require that the
   renderer supports creating a <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#CoglGLES2Context" title="CoglGLES2Context"><span class="type">CoglGLES2Context</span></a> via
   <a class="link" href="cogl-2.0-experimental-GLES-2.0-context.html#cogl-gles2-context-new" title="cogl_gles2_context_new ()"><code class="function">cogl_gles2_context_new()</code></a>. This can be used to integrate GLES 2.0
   code into Cogl based applications.
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-add-constraint"></a><h3>cogl_renderer_add_constraint ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_renderer_add_constraint        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> constraint</code></em>);</pre>
<p>
This adds a renderer selection <em class="parameter"><code>constraint</code></em>.
</p>
<p>
Applications should ideally minimize how many of these constraints they
depend on to ensure maximum portability.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>An unconnected <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>constraint</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> to add</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-renderer-remove-constraint"></a><h3>cogl_renderer_remove_constraint ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_renderer_remove_constraint     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> constraint</code></em>);</pre>
<p>
This removes a renderer selection <em class="parameter"><code>constraint</code></em>.
</p>
<p>
Applications should ideally minimize how many of these constraints they
depend on to ensure maximum portability.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>An unconnected <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>constraint</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRendererConstraint" title="enum CoglRendererConstraint"><span class="type">CoglRendererConstraint</span></a> to remove</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-xlib-renderer-set-foreign-display"></a><h3>cogl_xlib_renderer_set_foreign_display ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_xlib_renderer_set_foreign_display
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">Display</span> *display</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-xlib-renderer-get-foreign-display"></a><h3>cogl_xlib_renderer_get_foreign_display ()</h3>
<pre class="programlisting"><span class="returnvalue">Display</span> *           cogl_xlib_renderer_get_foreign_display
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="CoglXlibFilterFunc"></a><h3>CoglXlibFilterFunc ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    (*CoglXlibFilterFunc)               (<em class="parameter"><code><span class="type">XEvent</span> *event</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="CoglFilterReturn"></a><h3>enum CoglFilterReturn</h3>
<pre class="programlisting">typedef enum {
 /*&lt; prefix=COGL_FILTER &gt;*/
  COGL_FILTER_CONTINUE,
  COGL_FILTER_REMOVE
} CoglFilterReturn;
</pre>
<p>
Return values for the <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()"><span class="type">CoglXlibFilterFunc</span></a> and <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()"><span class="type">CoglWin32FilterFunc</span></a> functions.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><a name="COGL-FILTER-CONTINUE:CAPS"></a><span class="term"><code class="literal">COGL_FILTER_CONTINUE</code></span></p></td>
<td>The event was not handled, continues the
                       processing
</td>
</tr>
<tr>
<td><p><a name="COGL-FILTER-REMOVE:CAPS"></a><span class="term"><code class="literal">COGL_FILTER_REMOVE</code></span></p></td>
<td>Remove the event, stops the processing
</td>
</tr>
</tbody>
</table></div>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-xlib-renderer-add-filter"></a><h3>cogl_xlib_renderer_add_filter ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_xlib_renderer_add_filter       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()"><span class="type">CoglXlibFilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-xlib-renderer-remove-filter"></a><h3>cogl_xlib_renderer_remove_filter ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_xlib_renderer_remove_filter    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglXlibFilterFunc" title="CoglXlibFilterFunc ()"><span class="type">CoglXlibFilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-xlib-renderer-handle-event"></a><h3>cogl_xlib_renderer_handle_event ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    cogl_xlib_renderer_handle_event     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">XEvent</span> *event</code></em>);</pre>
</div>
<hr>
<div class="refsect2">
<a name="CoglWin32FilterFunc"></a><h3>CoglWin32FilterFunc ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    (*CoglWin32FilterFunc)              (<em class="parameter"><code><span class="type">MSG</span> *message</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
<p>
A callback function that can be registered with
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-add-filter" title="cogl_win32_renderer_add_filter ()"><code class="function">cogl_win32_renderer_add_filter()</code></a>. The function should return
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#COGL-FILTER-REMOVE:CAPS"><code class="literal">COGL_FILTER_REMOVE</code></a> if it wants to prevent further processing or
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#COGL-FILTER-CONTINUE:CAPS"><code class="literal">COGL_FILTER_CONTINUE</code></a> otherwise.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>message</code></em> :</span></p></td>
<td>A pointer to a win32 MSG struct</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>data</code></em> :</span></p></td>
<td>The data that was given when the filter was added</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-renderer-add-filter"></a><h3>cogl_win32_renderer_add_filter ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_win32_renderer_add_filter      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()"><span class="type">CoglWin32FilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
<p>
Adds a callback function that will receive all native events. The
function can stop further processing of the event by return
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#COGL-FILTER-REMOVE:CAPS"><code class="literal">COGL_FILTER_REMOVE</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>func</code></em> :</span></p></td>
<td>the callback function</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>data</code></em> :</span></p></td>
<td>user data passed to <em class="parameter"><code>func</code></em> when called</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-renderer-remove-filter"></a><h3>cogl_win32_renderer_remove_filter ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_win32_renderer_remove_filter   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglWin32FilterFunc" title="CoglWin32FilterFunc ()"><span class="type">CoglWin32FilterFunc</span></a> func</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *data</code></em>);</pre>
<p>
Removes a callback that was previously added with
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-add-filter" title="cogl_win32_renderer_add_filter ()"><code class="function">cogl_win32_renderer_add_filter()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>func</code></em> :</span></p></td>
<td>the callback function</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>data</code></em> :</span></p></td>
<td>user data given when the callback was installed</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-renderer-handle-event"></a><h3>cogl_win32_renderer_handle_event ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="returnvalue">CoglFilterReturn</span></a>    cogl_win32_renderer_handle_event    (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">MSG</span> *message</code></em>);</pre>
<p>
This function processes a single event; it can be used to hook into
external event retrieval (for example that done by Clutter or
GDK).
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>message</code></em> :</span></p></td>
<td>A pointer to a win32 MSG struct</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglFilterReturn" title="enum CoglFilterReturn"><span class="type">CoglFilterReturn</span></a>. <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#COGL-FILTER-REMOVE:CAPS"><code class="literal">COGL_FILTER_REMOVE</code></a> indicates that
Cogl has internally handled the event and the caller should do no
further processing. <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#COGL-FILTER-CONTINUE:CAPS"><code class="literal">COGL_FILTER_CONTINUE</code></a> indicates that Cogl is
either not interested in the event, or has used the event to update
internal state without taking any exclusive action.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-win32-renderer-set-event-retrieval-enabled"></a><h3>cogl_win32_renderer_set_event_retrieval_enabled ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_win32_renderer_set_event_retrieval_enabled
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> enable</code></em>);</pre>
<p>
Sets whether Cogl should automatically retrieve messages from
Windows. It defaults to <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a>. It can be set to <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> if the
application wants to handle its own message retrieval. Note that
Cogl still needs to see all of the messages to function properly so
the application should call <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-win32-renderer-handle-event" title="cogl_win32_renderer_handle_event ()"><code class="function">cogl_win32_renderer_handle_event()</code></a> for
each message if it disables automatic event retrieval.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>a <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>enable</code></em> :</span></p></td>
<td>The new value</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-wayland-renderer-set-foreign-display"></a><h3>cogl_wayland_renderer_set_foreign_display ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_wayland_renderer_set_foreign_display
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><span class="type">struct wl_display</span> *display</code></em>);</pre>
<p>
Allows you to explicitly control what Wayland display you want Cogl
to work with instead of leaving Cogl to automatically connect to a
wayland compositor.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>display</code></em> :</span></p></td>
<td>A Wayland display</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-wayland-renderer-set-event-dispatch-enabled"></a><h3>cogl_wayland_renderer_set_event_dispatch_enabled ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_wayland_renderer_set_event_dispatch_enabled
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> enable</code></em>);</pre>
<p>
Sets whether Cogl should handle calling <code class="function">wl_display_dispatch()</code> and
<code class="function">wl_display_flush()</code> as part of its main loop integration via
<a class="link" href="cogl-2.0-experimental-Main-loop-integration.html#cogl-poll-renderer-get-info" title="cogl_poll_renderer_get_info ()"><code class="function">cogl_poll_renderer_get_info()</code></a> and <a class="link" href="cogl-2.0-experimental-Main-loop-integration.html#cogl-poll-renderer-dispatch" title="cogl_poll_renderer_dispatch ()"><code class="function">cogl_poll_renderer_dispatch()</code></a>.
The default value is <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a>. When it is enabled the application can
register listeners for Wayland interfaces and the callbacks will be
invoked during <a class="link" href="cogl-2.0-experimental-Main-loop-integration.html#cogl-poll-renderer-dispatch" title="cogl_poll_renderer_dispatch ()"><code class="function">cogl_poll_renderer_dispatch()</code></a>. If the application
wants to integrate with its own code that is already handling
reading from the Wayland display socket, it should disable this to
avoid having competing code read from the socket.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>enable</code></em> :</span></p></td>
<td>The new value</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.16</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-wayland-renderer-get-display"></a><h3>cogl_wayland_renderer_get_display ()</h3>
<pre class="programlisting">struct <span class="returnvalue">wl_display</span> * cogl_wayland_renderer_get_display   (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a> *renderer</code></em>);</pre>
<p>
Retrieves the Wayland display that Cogl is using. If a foreign
display has been specified using
<a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-wayland-renderer-set-foreign-display" title="cogl_wayland_renderer_set_foreign_display ()"><code class="function">cogl_wayland_renderer_set_foreign_display()</code></a> then that display will
be returned. If no foreign display has been specified then the
display that Cogl creates internally will be returned unless the
renderer has not yet been connected (either implicitly or explicitly by
calling <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#cogl-renderer-connect" title="cogl_renderer_connect ()"><code class="function">cogl_renderer_connect()</code></a>) in which case <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> is returned.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>renderer</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-CoglRenderer---Connect-to-a-backend-renderer.html#CoglRenderer" title="CoglRenderer"><span class="type">CoglRenderer</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>The wayland display currently associated with <em class="parameter"><code>renderer</code></em>,
or <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#NULL:CAPS"><code class="literal">NULL</code></a> if the renderer hasn't yet been connected and no
foreign display has been specified.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.8</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>